#ifndef EDW_DISPLAYLIST_H
#define EDW_DISPLAYLIST_H

// Includes ////////////////////////////////////////////////////////////////

#include "EDW_Common.h"

// Classes /////////////////////////////////////////////////////////////////

namespace EDW
{
	class Display;

	class DisplayList
	{
	public:

		////////////////////////////////////////////////////////////////////
		// Public //////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////

		// Functions ///////////////////////////////////////////////////////

		DisplayList();
		DisplayList(const DisplayList &other);
		DisplayList &operator=(const DisplayList &other);
		~DisplayList();

		explicit operator bool() const;

		bool Load();
		int GetCount() const;
		bool IsValidIndex(int index) const;
		bool Get(int index, Display &display) const;
		bool Set(int index, const Display &display);

		////////////////////////////////////////////////////////////////////

	private:
		std::unique_ptr<struct DisplayListImpl> impl;
	};
}

////////////////////////////////////////////////////////////////////////////

#endif
