// Includes ////////////////////////////////////////////////////////////////

#include "UI.h"

// Functions ///////////////////////////////////////////////////////////////

UI::ScreenDC::ScreenDC() :
	DC(InitHandle()),
	references(new int(1))
{
}

////////////////////////////////////////////////////////////////////////////

UI::ScreenDC::ScreenDC(const ScreenDC &other) :
	DC(other),
	references(other.references)
{
	++*references;
}

////////////////////////////////////////////////////////////////////////////

UI::ScreenDC &UI::ScreenDC::operator=(ScreenDC other)
{
	DC::operator=(other);
	std::swap(references, other.references);
	return *this;
}

////////////////////////////////////////////////////////////////////////////

UI::ScreenDC::~ScreenDC()
{
	--*references;

	if (*references <= 0)
	{
		ReleaseDC(nullptr, GetHandle());
		delete references;
	}
}

////////////////////////////////////////////////////////////////////////////

HDC UI::ScreenDC::InitHandle() const
{
	HDC handle = GetDC(nullptr);

	if (!handle)
		throw L"GetDC failed.";

	return handle;
}

////////////////////////////////////////////////////////////////////////////
